(*
 * Copyright (c) 2002 Andr di Geronimo (adg@home.se)
 *)
 
unit P_Str;

interface

uses
  SysUtils;

type
  TStringArray = array of string;

function strMake(iCount : integer ; const s : string = ' ') : string;
function strTokenAt(const s, sSep : string ; iCount : integer) : string;
function strAlpha(const s : string) : string;
function strReplaceChar(const s : string ; cOld, cNew : char) : string;
function strSingleSpace(const s : string) : string;

implementation

{------------------------------------------------------------------------------}
function strMake(iCount : integer ; const s : string = ' ') : string;
var
  i : integer;
begin
  SetLength(Result, iCount);
  for i := 0 to iCount - 1 do
    Result := Result + s;
end;

{------------------------------------------------------------------------------}
function strTokenAt(const s, sSep : string ; iCount : integer) : string;
var
  sTmp : string;
  i, iPos, iPos2, iEnd : integer;
begin
  Result := '';
  iPos2  := 1;
  if s = '' then
    Exit;
  sTmp := Trim(s);
  for i := 0 to iCount-1 do begin
    iPos := Pos(sSep, sTmp);
    inc(iPos2, iPos);
    Delete(sTmp, 1, iPos);
  end;
  iEnd := Pos(' ', sTmp);
  if iEnd = 0 then
    iEnd := Length(s);
  Result := Trim(Copy(s, iPos2, iEnd));
end;

{------------------------------------------------------------------------------}
function strAlpha(const s : string) : string;
var
  i : integer;
  sResult : string;
begin
  for i := 1 to Length(s) do
    if s[i] in ['0'..'9'] then
      sResult := sResult + s[i];
  Result := sResult;
end;

{------------------------------------------------------------------------------}
function strReplaceChar(const s : string ; cOld, cNew : char) : string;
var
  i : integer;
  sResult : string;
begin
  sResult := s;
  for i := 1 to Length(sResult) do
    if sResult[i] = cOld then
      sResult[i] := cNew;
  Result := sResult;
end;

{------------------------------------------------------------------------------}
function strSingleSpace(const s : string) : string;
var
  i : integer;
begin
  for i := 1 to Length(s) do begin
    if i <> 1 then begin
      if not ((s[i] = ' ') and (s[i-1] = ' ')) then
        Result := Result + s[i];
    end
    else
      Result := s[i];
  end;
end;

end.
