unit QERadiant_Plugins;

interface

uses Windows;

const QER_PLUG_VERSION_1                = 1.00;
const QER_PLUG_VERSION                  = 1.50; //1.70
const QER_MAX_NAMELEN                   = 1024;

const QER_PLUG_GAME_TEXTURE             = $0001;       // defines new texture format
const QER_PLUG_GAME_MODEL               = $0002;       // defines new model format
const QER_PLUG_GAME_MAP                 = $0004;       // handles map load/save
const QER_PLUG_GAME_SURFACEDLG          = $0008;       // handles surface dialog
const QER_PLUG_GAME_SURFACEFLAGS        = $0010;       // renames surface/content names

const W_CAMERA	                	= $0001;
const W_XY	        	        = $0002;
const W_XY_OVERLAY                      = $0004;
const W_Z	        	        = $0008;
const W_TEXTURE		                = $0010;
const W_Z_OVERLAY       	        = $0020;
const W_CONSOLE	        	        = $0040;
const W_ENTITY		                = $0080;
const W_CAMERA_IFON                     = $0100;
const W_XZ                              = $0200;        //--| only used for patch vertex manip stuff
const W_YZ                              = $0400;        //--|
const W_GROUP                           = $0800;
const W_MEDIA                           = $1000;
const W_ALL		                = $FFFFFFF;

type
 TViewType = (YZ, XZ, XY);

 PVec3=^TVec3;
 TVec3=array[0..2] of single;

 PEPair=^TEPair;
 TEPair=record
  next: PEPair;
  key: PChar;
  value: PChar;
 end; {TEPair}

 PPatchmesh=^TPatchMesh;
 TPatchMesh=record
  {todo}
 end; {TPatchMesh}

 TBrushPrimit_TexDef = record
  coords:array[0..1] of array[0..2] of TVec3;
 end; {TBrushPrimit_TexDef}

 TQERPointData=record
  m_nCount:integer;
  m_pVectors:PVec3;
 end; {TQERPointData}

 PQERFaceData=^TQERFaceData;
 TQERFaceData=record
  TextureName:array[0..(QER_MAX_NAMELEN-1)] of char;
  Contents:longint;
  Flags:longint;
  Value:longint;
  Shift:array[0..2] of single;
  Rotate:single;
  Scale:array[0..2] of single;
  v1,m_v2,m_v3:TVec3;
  bBPrimit:boolean;
  brushprimit_texdef:TBrushPrimit_TexDef;
 end {TQERFaceData};

 TQERFuncTable=record
  Version: single;
  Size: integer;
  pCreateBrush: procedure(vMin,vMax:TVec3);pascal;
  pCreateBrushHandle: function:pointer;stdcall;
  pDeleteBrushHandle: procedure(pBrush:pointer);stdcall;
  pCommitBrushHandleToMap: procedure(pBrush:pointer);stdcall;
  pAddFace: procedure(pBrush:pointer;v1,v2,v3:TVec3);stdcall;
  pAddFaceData: procedure(pBrush:pointer;pFaceData:pQERFaceData);stdcall;
  pGetFaceData: function(pBrush:pointer;FaceIndex:integer):PQERFaceData;stdcall;
  pGetFaceCount: function(pBrush:pointer):integer;stdcall;
  pSetFaceData: procedure(pBrush:pointer;FaceIndex:integer;pFaceData:PQERFaceData);stdcall;
  pDeleteFace: procedure(pBrush:pointer;FaceIndex:integer);stdcall;
  pTextureBrush: procedure(pBrush:pointer;pName:LPCSTR);stdcall;
  pBuildBrush: procedure(pBrush:pointer);stdcall;
  pSelectBrush: procedure(pBrush:pointer);stdcall;
  pDeselectBrush: procedure(pBrush:pointer);stdcall;
  pDeselectAllBrushes: procedure;stdcall;
  pDeleteSelection: procedure;stdcall;
  pGetPoints: procedure(nMax:integer;PointData:TQERPointData;pMsg:LPCSTR);stdcall;
  pSysMsg: procedure(pMsg:LPCSTR);stdcall;
  pInfoMsg: procedure(pMsg:LPCSTR);stdcall;
  pHideInfoMsg: procedure;stdcall;
  pPositionView: procedure(v1,v2,v3:TVec3);stdcall;
  pSelectedBrushCount: function:integer;stdcall;
  pAllocateSelectedBrushHandles: function:integer;stdcall;
  pReleaseSelectedBrushHandles: procedure;stdcall;
  pGetSelectedBrushHandle: function(BrushIndex:integer):pointer;stdcall;
  pActiveBrushCount: function:integer;stdcall;
  pAllocateActiveBrushHandles: function:integer;stdcall;
  pReleaseActiveBrushHandles: procedure;stdcall;
  pGetActiveBrushHandle: function(BrushIndex:integer):pointer;stdcall;
  pTextureCount: function:integer;stdcall;
  pGetTexture: function(TexIndex:integer):pointer;stdcall;
  pGetCurrentTexture: function:LPCSTR;stdcall;
  pSetCurrentTexture: procedure(pname:LPCSTR);stdcall;
  pGetEClassCount: function:integer;stdcall;
  pGetEClass: function(ClassIndex:integer):LPCSTR;stdcall;
  pResetPlugins: procedure;stdcall;
  pLoadTextureRGBA: procedure(pTex:pointer);stdcall;
  // 1.5 ends here
//  pGetEntityCount: function:integer;stdcall;
//  pGetEntityHandle: function(EntityIndex:integer):pointer;stdcall;
//  pGetEntityKeyValList: function(pEntity:pointer):PEPair;stdcall;
//  pSetEntityKeyValList: procedure(pEntity:pointer;entityData:PEPair);stdcall;
//  pAllocateEntityBrushHandles: function(pEntity:pointer):integer;stdcall;
//  pReleaseEntityBrushHandles: procedure;stdcall;
//  pGetEntityBrushHandle: function(EntityIndex:integer):pointer;stdcall;
//  pCreateEntityHandle: function:pointer;stdcall;
//  pCommitBrushHandleToEntity: procedure(pBrush,pEntity:pointer);stdcall;
//  pCommitEntityHandleToMap: procedure(pEntity:pointer);stdcall;
//  pAllocateEpair: function(e1,e2:pChar):PEPair;stdcall;
//  pSetScreenUpdate: procedure(ScreenUpdate:integer);stdcall;
//  pSysUpdateWindows: procedure(Bits:integer);stdcall;
//  pBuildBrush2: procedure(pBrush:pointer;convert:integer);stdcall;
//  pReadProjectKey: function(pKey:PChar):PChar;stdcall;
//  pScanFileForEClass: function(pClass:pointer):integer;stdcall;
//  pRequestInterface:function(a:TGUID;b:pointer):integer;stdcall;
//  pErrorMsg: procedure(pMsg:LPCSTR);stdcall;
//  pLoadFile: function(pLocation:PChar;buffer:pointer):integer;stdcall;
//  pExpandReletivePath: function(pName:PChar):PChar;stdcall;
//  pConvertDOSToUnixName: procedure(pDst:PChar;const pSrc:PChar);stdcall;
//  pHasShader: function(const pName:PChar):integer;stdcall;
//  pTextureLoadSkin: function(pName:PChar;Width,Height:integer):integer;stdcall;
//  pRadiantFree: function(p:pointer):pointer;stdcall;
//  pGetGamePath: function:pChar;stdcall;
//  pGetQERPath: function:pChar;stdcall;
//  pAllocateActivePatchHandles: function:integer;stdcall;
//  pAllocateSelectedPatchHandles: function:integer;stdcall;
//  pReleasePatchHandles: procedure;stdcall;
//  pGetPatchData: function(PatchIndex:integer):PPatchMesh;stdcall;
//  pDeletePatch: procedure(PatchIndex:integer);stdcall;
//  pCreatePatchHandle: function:integer;stdcall;
//  pCommitPatchHandleToMap: procedure(a:integer;pPatch:PPatchMesh;TexName:char);stdcall;
 end; {TQERFuncTable}

implementation

end.
